# Luminous Forts
# Hekar Khani

# Quickly made script for adding a gameconfig to Hammer with a given template

import os
import shutil

from datetime import datetime

gameconfig_path = "GameConfig.txt"
template_path = "GameConfigLuminousForts.txt"

modname = "LuminousForts"
modfoldername = "luminousforts"

class InstallGameConfig (object):
    def __init__ (s, templatepath, drive, username):
        s.templatepath = templatepath
        s.drive = drive
        s.username = username
    
    # path to template, drive letter to be installed ie "C:"
    def setup_hammer (s, modname, modfoldername):
        global gameconfig_path
		
        fh = open (s.templatepath, 'r')
        templatelines = fh.readlines ()
        fh.close ()

        # replace the drive identifier
        templatebuf = ""
        for line in templatelines:
            line = line.replace ("C:", s.drive)
            line = line.replace ("username", s.username)
            line = line.replace ("modname", modname)
            line = line.replace ("modfolder", modfoldername)
            templatebuf += line
            
        fh = open (gameconfig_path, 'r')
        gameconflines = fh.readlines ()
        fh.close ()

        gameconfbuf = ""
        for line in gameconflines:
            gameconfbuf += line


        if gameconfbuf.find (templatelines [0]) > 0:
            print "Warning %s is already in GameConfig.txt" % (templatelines [0].strip ("\t\n")) 
 
        # day, month, year, minute
        datestring = datetime.now ().strftime ("%d%m%y%M")
        backup_path = gameconfig_path.replace (".txt", "")+ datestring + ".txt"
        # backup_path = "GameConfig.bak"
        shutil.copy (gameconfig_path, backup_path)

        lastbraceindex = gameconfbuf.rfind ("}")

        secondlastbraceindex = gameconfbuf.rfind ("}", 0, lastbraceindex - 1)

        # Defaults to version 3 anyway
        SDKVersion = '"SDKVersion"\t"3"'
        if gameconfbuf.rfind ("SDKVersion") < 0:
            print "SDK Version not found... Defaulting to Version 3"

        gameconfbuf = gameconfbuf [0:secondlastbraceindex] + templatebuf + "\n\t}\n\t" + SDKVersion + "\n}\n"


        # finally write to GameConfig
        fh = open (gameconfig_path, 'w')
        fh.write (gameconfbuf)
        fh.close ()

def RestoreGameConfig (object):
    def __init__ (s):
        pass
    
def setup_hammer (templatepath, drive, username):
	global modname
	global modfoldername
    installlf = InstallGameConfig (templatepath, drive, username)
    installlf.setup_hammer (modname, modfoldername)

def restore (filename):
    pass

def main ():
    global template_path
    setup_hammer (template_path, "E:", "hekark")

main ()
